class AdminMenu {

	constructor() {
		this.timer;
		this.menu = document.querySelector('.menu');
		this.error = {message: {type: "error", txt: lang[613], timer:4000, button: ""}};
		this.ObjTab = {menu:
			{
				tarif: {name: lang[609], tabhead: lang[611], remove: lang[615]},
				group: {name: lang[610], tabhead: lang[612], remove: lang[616]},
				router: {name: lang[622], tabhead: lang[623], remove: lang[625]},
				config: {name: lang[700], tabhead: lang[700], remove: ''},
			}
		}
		this.responseLoc;
	}

	Read() {
		if(this.menu)
			this.menu.onclick = function() {
				if(this.menu == event.target)
					if(this.menu.classList.contains('active')) this.Clear()
					else this.ViewMenu();
			}.bind(this)
	}

	Clear() {
		this.menu.classList.remove('active');
		this.menu.querySelector('.setup').remove();
	}

	ViewMenu() {
		var tab = '';
		for (var key in this.ObjTab.menu) {tab += '<li data-set="' + key + '"' + (key == get['page'] ? ' class="active"' : '') + '>' + this.ObjTab.menu[key].name + '</li>'}
		this.menu.classList.add('active');
		this.menu.insertAdjacentHTML('afterBegin', '\
			<div class="setup">\
				<div class="nav-tab">\
					<ul>\
						'+ tab +'\
					</ul>\
				</div>\
				<div id="searchdiv">\
					<input type="text" name="search" id="search" value="" placeholder="'+lang[614]+'" autocomplete="off">\
				</div>\
				<div>\
					<div class="result">\
					</div>\
				</div>\
			</div>');

		this.menu.querySelector('input').focus();
		var that = this.menu.querySelector('.setup .nav-tab');

		if(!that.querySelector('.active')) that.querySelector('li').classList.add('active');
		this.Get(that.querySelector('li.active').dataset.set);

		that.onclick = function() {	
			if(event.target.dataset.set) {
				var active = that.querySelector('.active');
				if(active) active.classList.remove('active');
				event.target.classList.add('active');
				this.Get(event.target.dataset.set);
				this.menu.querySelector('input').focus();
				this.menu.querySelector('input').value = "";
			}
		}.bind(this)

		this.menu.querySelector('[name="search"]').onkeyup = function() {
			this.ListView(that.querySelector('.active').dataset.set);
		}.bind(this)

		document.onclick = function(e){
			var Menu = e.target == this.menu || this.menu.contains(e.target) || !!document.querySelector('.popup');				  
			if (!Menu) {document.onclick = null; this.Clear();}
		}.bind(this)
	}

	ListView(action, mess = false) {
		var res = this.menu.querySelector('.result');
		var val = this.menu.querySelector('[name="search"]');
		var out = '';
		
		if (document.getElementById("isadmin").value == '1'){
			out = (this.responseLoc.settings != undefined ? '<a href="#" class="set ' + action + '">' + lang[700] + '</a>' : '');
		} else {
			out = (this.responseLoc.settings != undefined ? '<a href="#" class="set ' + action + '" style="cursor: not-allowed;color: gray;">' + lang[700] + '</a>' : '');
		}
		
		var dis = false;
		if (((action == 'tarif') && (document.getElementById("tariff_priv").value == '0')) ||
			((action == 'group') && (document.getElementById("group_priv").value == '0')) ||
			((action == 'router') && (document.getElementById("router_priv").value == '0'))){
			out = out + (this.ObjTab.menu[action].tabhead ? '<a href="#" class="add" style="cursor: not-allowed;color: gray;">' + this.ObjTab.menu[action].tabhead + '</a>' : '');
			dis = true;
		} else {
			out = out + (this.ObjTab.menu[action].tabhead ? '<a href="?page=' + action + '" class="add">' + this.ObjTab.menu[action].tabhead + '</a>' : '');
		}
					
		if (this.responseLoc.message != undefined && this.responseLoc.message != undefined) PopUp(this.responseLoc);
		if(this.responseLoc && this.responseLoc.list != undefined && this.responseLoc.message == undefined) {
			var layout = 1;
			var set
			
			if (dis){
				set = v => '';
			} else {
				set = v => ' <span>' + 
				(v.swith != undefined ? '<i data-set="swith"' + (v.swith ? ' class="on"' : '') + '><b></b></i>' : '')
				+ '<i data-set="remove"></i></span></a>';
			}
			 
	
				
			this.responseLoc.list.forEach(function(v){
				if(val && val.value.length > 0 && v.name.toLowerCase().indexOf(val.value.toLowerCase()) == -1) return;
				if (dis){
					out += '<a href="#" style="cursor: not-allowed;color: gray;">' + v.name + set(v);
				} else {
					out += '<a href="?page=' + action + '&id='+ v.id + '" data-id="' + v.id + '">' + v.name + set(v);
				}
				
				layout++;
			});
			if(layout == 1)
				this.responseLoc.list.forEach(function(v){
					if(val && val.value.length > 0 && v.name.toLowerCase().indexOf(val.value.translit(true).toLowerCase()) == -1) return;
					out += '<a href="?page=' + action + '&id='+ v.id + '" data-id="' + v.id + '">' + v.name + set(v);
				});
		}
		res.innerHTML = out;
		res.className = 'result ' + action;
		this.Action(action, res);		
		res.style.maxHeight = 'calc(100vh - 6px - ' + getComputedStyle(res).marginTop + ' - ' + getComputedStyle(res).marginBottom +' - ' + res.getBoundingClientRect().top + 'px)';
	}

	Get(action) {
		
		if (action != 'config'){
			document.getElementById("searchdiv").style.visibility = "visible";
			var send = {action: 'list' + action};
			var res = this.menu.querySelector('.result');
			res.classList.add('load');		
			fetch('./api-json.php', {method: 'POST', headers: {'Content-Type': 'application/json'}, credentials: 'include', body: JSON.stringify(send)})
			.then((resp) => resp.json())
			.then(response => {
				this.responseLoc = response;
				this.ListView(action);
			}, error => {res.innerHTML = lang[613];res.classList.remove('load')}) 
		} else {
			document.getElementById("searchdiv").style.visibility = "hidden";
			var res = this.menu.querySelector('.result');
			if (document.getElementById("isadmin").value == '1'){
				res.innerHTML = '<a href="#" onclick="Reboot(this);" class="set router">' + lang[887] + '</a>';
			} else {
				res.innerHTML = '<a href="#" class="set router" style="cursor: not-allowed;color: gray;">' + lang[887] + '</a>';
			}
		}
	}
		
	Action(action, res) {
		Array.from(res.querySelectorAll('a')).forEach(function(v){
			v.onclick =  function(e) {

				if (v.style.cursor == 'not-allowed'){return false;}
				
				let send = {},
					set = e.target.closest('[data-set]') || false,
					func = (send, f) => fetch('./api-json.php', {method: 'POST', headers: {'Content-Type': 'application/json'}, credentials: 'include', body: JSON.stringify(send)})
						.then((resp) => resp.json())
						.then(response => {
							if(response.message != undefined) PopUp(response);
							if(response.action != undefined && response.action === true) f();
							res.classList.remove('load');						 
							}, error => {res.classList.remove('load'); PopUp(this.error);}) 
				if(set && set.dataset.set == "remove") { 
					PopUp({message: {type: 'confirm', txt: this.ObjTab.menu[action].remove + ' «' + v.innerText + '»', button: ['', '']}});					
					document.querySelector('.popup button').addEventListener('click', function(){
						res.classList.add('load');
						send = {action: 'delete' + action, id: v.dataset.id};
						func(send, () => v.remove());
						}.bind(this), false); 					
					return false;
				}
				if(set && set.dataset.set == "swith") {
					res.classList.add('load');
					send = {action: 'swith' + action, state: !set.classList.contains('on'), id: v.dataset.id};
					func(send, () => set.classList.toggle('on'));
					return false;
				}
				if(e.target.classList.contains("set", action)) {
					this.SettingBox(action, res, func);					
					return false;
				}
			}.bind(this)		
		}.bind(this))
	}

	SettingBox (action, res, func) {
		
		var set = {
			"router" : '\
				<div class="row">\
				<div class="cell">' + lang[701] + '</div>\
				</div>\
				<div class="row">\
					<div class="cell_1">' + lang[702] + ':</div>\
					<div class="cell_2"><input type="text" name="RefreshInterval" value="10" class="1/4"></div>\
				</div>\
				<div class="row">\
					<div class="cell_1">' + lang[703] + ':</div>\
					<div class="cell_2"><label><input type="checkbox" name="DisplaceActivation" checked="true"><i></i></label></div>\
				</div>'
		};
		if(set[action] != undefined) {
			document.body.insertAdjacentHTML('afterBegin', '\
				<div class="fon">\
					<form class="settings ' + action + ' popup">\
						' + set[action] + '\
						<div class="row cnfrm"><button type="button">' + lang[53] + '</button><button type="button">' + lang[366] + '</button></div>\
					</form>\
				</div>');
			var form = document.querySelector('.fon form.settings');
			Object.keys(form).forEach(v => {
				if (this.responseLoc.settings[form[v].name] != undefined) {
					if (form[v].type == 'checkbox') form[v].checked = this.responseLoc.settings[form[v].name];
					if (form[v].type == 'text' || form[v].type == 'select-one' || form[v].type == 'textarea') form[v].value = this.responseLoc.settings[form[v].name];				
				}
			});
			document.querySelector('.fon').onclick = document.querySelector('.fon button + button').onclick = function() {
				if (this == event.target) ClosePopUp();
			}
			document.querySelector('.fon button').onclick = function() {
				this.responseLoc.settings = {};
				Array.from(form).forEach((v) => {v.name ? this.responseLoc.settings[v.name] = v.type == 'checkbox' ? v.checked : v.value : ''});
				var send = {action: 'SETTINGS_' + action.toUpperCase(), settings: this.responseLoc.settings};
				func(send, () => {})
				ClosePopUp();
			}.bind(this)
		} else console.log('ERROR :: SettingBox - ' + action + ' not found!')
	}
}

document.addEventListener('DOMContentLoaded', function() {
	var AdminMenuObj = new AdminMenu();
	AdminMenuObj.Read();
})

var get = window
    .location
    .search
    .replace('?','')
    .split('&')
    .reduce(
        function(p,e){
            var a = e.split('=');
            p[ decodeURIComponent(a[0])] = decodeURIComponent(a[1]);
            return p;
        },
        {}
    );

function PopUp(obj){
	var timer;
	document.body.insertAdjacentHTML('afterBegin', '\
			<div class="fon' + (obj.message.type != undefined ? ' ' + obj.message.type : '' ) + '">\
				<div class="popup' + (obj.message.type != undefined ? ' ' + obj.message.type : '' ) + '">\
					<div class="txt">' + obj.message.txt + '</div>\
					<div class="load"></div>\
				</div>\
			</div>');
	var action = function(){
		if(obj.message.redirect != undefined) window.location.href = obj.message.redirect;
		else ClosePopUp()
	}
	if(obj.message.button != undefined) {
		var def = ['Ok', 'Cancel'];
		if(obj.message.button instanceof Array != true) obj.message.button = [''];
		obj.message.button.forEach(function(v, k){
			var b = document.createElement("button"); 
			b.innerText = v ? v : def[k];			
			b.onclick = function(){clearInterval(timer); action()};
			document.querySelector(".popup").appendChild(b);
		})
	}
	if(obj.message.timer != undefined) {
		timer = setTimeout(function(){action()}, obj.message.timer);
		setTimeout(function(){document.querySelector(".popup .load").style.cssText='opacity:1;transition:width linear ' + obj.message.timer + 'ms;width:0%'}, 40);
	}
}

function ClosePopUp(){
	var p = document.querySelector('.fon:not(.close)');
	//var p = document.querySelectorAll('.fon:not(.close)');
	//p = p[p.length - 1];
	p.classList.add('close');
	setTimeout(function(){p.remove()}, 250);
}

function animate({timing, draw, duration}) {					
	let start = performance.now();
	requestAnimationFrame(function animate(time) {
		let timeFraction = (time - start) / duration;
		if (timeFraction > 1) 
			timeFraction = 1;
		let progress = timing(timeFraction);
		draw(progress);
		if (timeFraction < 1) 
			requestAnimationFrame(animate);
	});
}

function Reboot(Obj){
	if (Obj.style.cursor != 'not-allowed'){
		if (confirm(lang[888])){
			var request=null;
			request=new XMLHttpRequest();
			request.open('GET', 'api.php?action=RESTART_SERVICE');
			request.msCaching = 'disabled';	// for IE
			request.responseType = 'text';
			request.send(null);	
			request.onreadystatechange = function() {
			}	
		}
	}
}

String.prototype.translit = (function () {	
        return function (EnLang) {		
		    var L;
			var r = '',k;	
			if (EnLang == false) {
				L = {
					'Й': 'Q', 'Ц': 'W', 'У': 'E', 'К': 'R', 'Е': 'T', 'Н': 'Y', 'Г': 'U', 'Ш': 'I',
					'Щ': 'O', 'З': 'P', 'Х': '[', 'Ъ': ']', 'Ф': 'A', 'Ы': 'S', 'В': 'D', 'А': 'F',
					'П': 'G', 'Р': 'H', 'О': 'J', 'Л': 'K', 'Д': 'L', 'Ж': ';', 'Э': "'", 'Я': 'Z',
					'Ч': 'X', 'С': 'C', 'М': 'V', 'И': 'B', 'Т': 'N', 'Ь': 'M', 'Б': ',', 'Ю': '.',
					'.': '/',
					'й': 'q', 'ц': 'w', 'у': 'e', 'к': 'r', 'е': 't', 'н': 'y', 'г': 'u', 'ш': 'i',
					'щ': 'o', 'з': 'p', 'х': '[', 'ъ': ']', 'ф': 'a', 'ы': 's', 'в': 'd', 'а': 'f',
					'п': 'g', 'р': 'h', 'о': 'j', 'л': 'k', 'д': 'l', 'ж': ';', 'э': "'", 'я': 'z',
					'ч': 'x', 'с': 'c', 'м': 'v', 'и': 'b', 'т': 'n', 'ь': 'm', 'б': ',', 'ю': '.'
				};
			} else {
				L = {
					'Q': 'Й', 'W': 'Ц', 'E': 'У', 'R': 'К', 'T': 'Е', 'Y': 'Н', 'U': 'Г', 'I': 'Ш',
					'O': 'Щ', 'P': 'З', 'A': 'Ф', 'S': 'Ы', 'D': 'В', 'F': 'А',
					'G': 'П', 'H': 'Р', 'J': 'О', 'K': 'Л', 'L': 'Д', ';': 'Ж', "'": "'", 'Z': 'Я',
					'X': 'Ч', 'C': 'С', 'V': 'М', 'B': 'И', 'N': 'Т', 'M': 'Ь', ',': 'Б', '.': 'Ю',
					'q': 'й', 'w': 'ц', 'e': 'у', 'r': 'к', 't': 'е', 'y': 'н', 'u': 'г', 'i': 'ш',
					'o': 'щ', 'p': 'з', 'a': 'ф', 's': 'ы', 'd': 'в', 'f': 'а',
					'g': 'п', 'h': 'р', 'j': 'о', 'k': 'л', 'l': 'д', ';': 'ж', "'": "'", 'z': 'я',
					'x': 'ч', 'c': 'с', 'v': 'м', 'b': 'и', 'n': 'т', 'm': 'ь', ',': 'б', '.': 'ю', '/':'.'
				};
			}
			for (k in L) r += k;
			r = new RegExp('[' + r + ']', 'g');
			k = function (a) {
				return a in L ? L[a] : '';
			};		
            var text_string = this.replace(r, k).replace(' ', '-').toString();
            var literals;
			if (EnLang == false ) {
				literals = 'QqWwEeRrTtYyUuIiOoPpAaSsDdFfGgHhJjKkLlZzXxCcVvBbNnMm-0123456789_';
			} else {literals = 'ЙйЦцУуКкЕеНнГгШшЩщЗзХхЪъФфЫыВвАаПпРрОоЛлДдЖжЭэЯяЧчСсМмИиТтЬьБбЮю.-0123456789_';}
            var newString = '';
            for (var i = 0; i < text_string.length; i++) {
                if (!(literals.indexOf(text_string.charAt(i)) == -1)) {
                    newString += text_string.charAt(i); 
                };
            };
            return newString;
        };
    })();